org.apache.commons.math3.optim.univariate

## Class MultiStartUnivariateOptimizer

- java.lang.Object
- - org.apache.commons.math3.optim.BaseOptimizer<UnivariatePointValuePair>
  - - org.apache.commons.math3.optim.univariate.UnivariateOptimizer
    - - org.apache.commons.math3.optim.univariate.MultiStartUnivariateOptimizer

    public class MultiStartUnivariateOptimizer
    extends UnivariateOptimizer

Special implementation of the `UnivariateOptimizer` interface adding multi-start features to an existing optimizer.
This class wraps an optimizer in order to use it several times in turn with different starting points (trying to avoid being trapped in a local extremum when looking for a global one).

Since:
  3.0
Version:
  $Id$

### Field Summary

Fields
`private RandomGenerator` `generator` Random generator for multi-start.
`private int` `maxEvalIndex` Location in `optimData` where the updated maximum number of evaluations will be stored.
`private UnivariatePointValuePair[]` `optima` Found optima.
`private OptimizationData[]` `optimData` Optimization data.
`private UnivariateOptimizer` `optimizer` Underlying classical optimizer.
`private int` `searchIntervalIndex` Location in `optimData` where the updated start value will be stored.
`private int` `starts` Number of starts to go.
`private int` `totalEvaluations` Number of evaluations already performed for all starts.

### Fields inherited from class org.apache.commons.math3.optim.BaseOptimizer

`evaluations, iterations`

### Constructor Summary

Constructors
Constructor and Description
`MultiStartUnivariateOptimizer(UnivariateOptimizer optimizer, int starts, RandomGenerator generator)` Create a multi-start optimizer from a single-start optimizer.

### Method Summary

Methods
`protected UnivariatePointValuePair` `doOptimize()` Performs the bulk of the optimization algorithm.
`int` `getEvaluations()` Gets the number of evaluations of the objective function.
`UnivariatePointValuePair[]` `getOptima()` Gets all the optima found during the last call to `optimize`.
`UnivariatePointValuePair` `optimize(OptimizationData... optData)` Stores data and performs the optimization.
`private void` `sortPairs(GoalType goal)` Sort the optima from best to worst, followed by `null` elements.

### Methods inherited from class org.apache.commons.math3.optim.univariate.UnivariateOptimizer

`computeObjectiveValue, getGoalType, getMax, getMin, getStartValue`

### Methods inherited from class org.apache.commons.math3.optim.BaseOptimizer

`getConvergenceChecker, getIterations, getMaxEvaluations, getMaxIterations, incrementEvaluationCount, incrementIterationCount`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### optimizer

    private final UnivariateOptimizer optimizer

Underlying classical optimizer.

#### totalEvaluations

    private int totalEvaluations

Number of evaluations already performed for all starts.

#### starts

    private int starts

Number of starts to go.

#### generator

    private RandomGenerator generator

Random generator for multi-start.

#### optima

    private UnivariatePointValuePair[] optima

Found optima.

#### optimData

    private OptimizationData[] optimData

Optimization data.

#### maxEvalIndex

    private int maxEvalIndex

Location in `optimData` where the updated maximum number of evaluations will be stored.

#### searchIntervalIndex

    private int searchIntervalIndex

Location in `optimData` where the updated start value will be stored.

### Constructor Detail

#### MultiStartUnivariateOptimizer

    public MultiStartUnivariateOptimizer(UnivariateOptimizer optimizer,
                                 int starts,
                                 RandomGenerator generator)

Create a multi-start optimizer from a single-start optimizer.

Parameters:
  `optimizer` - Single-start optimizer to wrap.
  `starts` - Number of starts to perform. If `starts == 1`, the `optimize` methods will return the same solution as `optimizer` would.
  `generator` - Random generator to use for restarts.
Throws:
  `NotStrictlyPositiveException` - if `starts < 1`.

### Method Detail

#### getEvaluations

    public int getEvaluations()

Gets the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

Overrides:
  `getEvaluations` in class `BaseOptimizer<UnivariatePointValuePair>`
Returns:
  the number of evaluations of the objective function.

#### getOptima

    public UnivariatePointValuePair[] getOptima()

Gets all the optima found during the last call to `optimize`. The optimizer stores all the optima found during a set of restarts. The `optimize` method returns the best point only. This method returns all the points found at the end of each starts, including the best one already returned by the `optimize` method.
The returned array as one element for each start as specified in the constructor. It is ordered with the results from the runs that did converge first, sorted from best to worst objective value (i.e in ascending order if minimizing and in descending order if maximizing), followed by `null` elements corresponding to the runs that did not converge. This means all elements will be `null` if the `optimize` method did throw an exception. This also means that if the first element is not `null`, it is the best point found across all starts.

Returns:
  an array containing the optima.
Throws:
  `MathIllegalStateException` - if `optimize` has not been called.

#### optimize

    public UnivariatePointValuePair optimize(OptimizationData... optData)

Stores data and performs the optimization.

Overrides:
  `optimize` in class `UnivariateOptimizer`
Parameters:
  `optData` - Optimization data. The following data will be looked for:
  - `GoalType`
  - `SearchInterval`
  - `UnivariateObjectiveFunction`
Returns:
  a point/value pair that satifies the convergence criteria.
Throws:
  `MathIllegalStateException` - if `optData` does not contain an instance of `MaxEval` or `SearchInterval`.

#### doOptimize

    protected UnivariatePointValuePair doOptimize()

Performs the bulk of the optimization algorithm.

Specified by:
  `doOptimize` in class `BaseOptimizer<UnivariatePointValuePair>`
Returns:
  the point/value pair giving the optimal value of the objective function.

#### sortPairs

    private void sortPairs(GoalType goal)

Sort the optima from best to worst, followed by `null` elements.

Parameters:
  `goal` - Goal type.